<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class ValidacoesParametrosFaturamentoFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function validarSePeriodoDeCompetenciaExiste($nomeTabela, $nomeCampoPK, $nomeCampoPai, $params) {
        $sql = "SELECT COUNT(*) AS EXISTE
                  FROM $nomeTabela
                 WHERE (:DIAINI BETWEEN (((IDMESCOMPETINI-1) * 31) + NRDIACOMPETINI) AND (((IDMESCOMPETFIN-1) * 31) + NRDIACOMPETFIN)
                    OR :DIAFIN BETWEEN (((IDMESCOMPETINI-1) * 31) + NRDIACOMPETINI) AND (((IDMESCOMPETFIN-1) * 31) + NRDIACOMPETFIN))
                   AND $nomeCampoPK <> :VALOR_CAMPO_PK
                   AND $nomeCampoPai = :VALOR_CAMPO_PAI
                   AND NRORG = :NRORG";
        
        $ps = $this->connection->prepare($sql);
        $ps->execute($params);
        return $ps->fetchAll();
    }
}

?>