/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPORECE                                                 */
/* Tabela : TIPORECE                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 25/03/2004 - WELBERT G.MOITINHA                                            */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_TIPORECE
BEFORE INSERT OR UPDATE OR DELETE
ON TIPORECE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTIPR := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUTIPR := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPORECE', '', 'CDTIPORECE='||:OLD.CDTIPORECE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPORECE MODIFY DTULTATUTIPR DEFAULT SYSDATE
/

UPDATE TIPORECE SET DTULTATUTIPR = SYSDATE WHERE DTULTATUTIPR IS NULL
/

